#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct iana_iftype {
	char *name;
	int number;
	char *descr;
	struct iana_iftype *next;
} *table = 0, *prev = 0;

void
mib2h(fp)
	FILE *fp;
{
	int found = 0;
	char *cp, buf[BUFSIZ];
	char *np, *dp;
	struct iana_iftype *tp;

	while (fgets(buf, sizeof(buf), fp)) {
		buf[sizeof(buf)-1] = '\0';
		cp = strchr(buf, '\n');
		if (cp) {
			if (cp-1 >= buf && *(cp-1) == '\r')
				*(cp-1) = '\0';
			else	*cp = '\0';
		}
		for (cp = buf; *cp && (*cp == ' ' || *cp == '\t'); cp++);
		if (*cp == '\0' || *cp == '-') continue;
		if (!found) {
			if (!strncmp(cp, "SYNTAX ", 7))
				found = 1;
			continue;
		}
		for (dp = &buf[strlen(buf)-1]; dp > buf &&
		     (*dp == ' ' || *dp == '\t'); dp--);
		if (*dp) *++dp = '\0';
		for (np = cp; *np && *np != '('; np++) {
			if (*np == '-') *np = '_';
			else if (*np == ' ' || *np == '\t') *np = '\0';
		}
		if (*np != '(') continue;
		*np++ = '\0';
		dp = strchr(np, ')');
		if (!dp) continue;
		*dp++ = '\0';
		while (*dp && (*dp == ' ' || *dp == '\t' ||
			       *dp == ',' || *dp == '-')) dp++;

		tp = malloc(sizeof(struct iana_iftype));
		if (!tp) continue;
		memset(tp, 0, sizeof(struct iana_iftype));
		tp->name = strdup(cp);
		tp->number = atoi(np);
		tp->descr = strdup(dp);
		if (!prev)
			table = tp;
		else	prev->next = tp;
		prev = tp;
	}
}

int
main(argc, argv)
	int argc;
	char **argv;
{
	int cnt = 0;
	struct iana_iftype *tp;
	if (argc > 1) {
		int i;
		for (i = 1; i < argc; i++) {
			FILE *fp = fopen(argv[i], "r");
			if (fp) {
				mib2h(fp);
				fclose(fp);
			} else	perror(argv[1]);
		}
	} else	mib2h(stdin);

/*	for (tp = table; tp; tp = tp->next)
		printf("#define ifType_%s %d\n", tp->name, tp->number);
	for (tp = table; tp; tp = tp->next) {
		printf(" { \"%s\", ifType_%s, \"%s\" },\n",
		       tp->name, tp->name, tp->descr);
		cnt++;
	}
*/
	for (tp = table; tp; tp = tp->next) {
		printf(" { \"%s\", %d, Interface },\n",
		       *tp->descr ? tp->descr : tp->name, tp->number);
		cnt++;
	}
	return cnt;
}

