/*
 *	Copyright (c) 1999-2003 Rinet Corp., Novosibirsk, Russia
 *
 * Redistribution and use in source forms, with and without modification,
 * are permitted provided that this entire comment appears intact.
 *
 * THIS SOURCE CODE IS PROVIDED ``AS IS'' WITHOUT ANY WARRANTIES OF ANY KIND.
 */

#ifdef	HAVE_CONFIG_H
#include <config.h>
#endif

#include <string.h>

#include "netmon.h"
#include "snmp.h"
#include "mib.h"

/*
 * SNMP MIB variable names and it hard coded OIDs.
 */

/*
 * System variables.
 */
const oid sysDescr[]		= { 1,3,6,1,2,1,1,1,0 };
const oid sysObjID[]		= { 1,3,6,1,2,1,1,2,0 };
const int sysObjID_len		= SV_LEN(sysObjID);
const oid sysUpTime[]		= { 1,3,6,1,2,1,1,3,0 };
const oid sysContact[]		= { 1,3,6,1,2,1,1,4,0 };
const oid sysName[]		= { 1,3,6,1,2,1,1,5,0 };
const oid sysLocation[]		= { 1,3,6,1,2,1,1,6,0 };
const oid sysServices[]		= { 1,3,6,1,2,1,1,7,0 };

const oid ifNumber[]		= { 1,3,6,1,2,1,2,1,0 };
const oid ifTableLastChange[]	= { 1,3,6,1,2,1,31,1,5,0 };

/*
 * Interface table.
 */
const oid ifIndex[]		= { 1,3,6,1,2,1,2,2,1,1,0 };
const oid ifDescr[]		= { 1,3,6,1,2,1,2,2,1,2,0 };
const oid ifType[]		= { 1,3,6,1,2,1,2,2,1,3,0 };
const oid ifMtu[]		= { 1,3,6,1,2,1,2,2,1,4,0 };
const oid ifSpeed[]		= { 1,3,6,1,2,1,2,2,1,5,0 };
const oid ifPhysAddress[]	= { 1,3,6,1,2,1,2,2,1,6,0 };
const oid ifAdminStatus[]	= { 1,3,6,1,2,1,2,2,1,7,0 };
const oid ifOperStatus[]	= { 1,3,6,1,2,1,2,2,1,8,0 };
const oid ifLastChange[]	= { 1,3,6,1,2,1,2,2,1,9,0 };
const oid ifInOctets[]		= { 1,3,6,1,2,1,2,2,1,10,0 };
const oid ifInUcastPkts[]	= { 1,3,6,1,2,1,2,2,1,11,0 };
const oid ifInNUcastPkts[]	= { 1,3,6,1,2,1,2,2,1,12,0 };
const oid ifInDrops[]		= { 1,3,6,1,2,1,2,2,1,13,0 };
const oid ifInErrors[]		= { 1,3,6,1,2,1,2,2,1,14,0 };
const oid ifInUnknownProtos[]	= { 1,3,6,1,2,1,2,2,1,15,0 };
const oid ifOutOctets[]		= { 1,3,6,1,2,1,2,2,1,16,0 };
const oid ifOutUcastPkts[]	= { 1,3,6,1,2,1,2,2,1,17,0 };
const oid ifOutNUcastPkts[]	= { 1,3,6,1,2,1,2,2,1,18,0 };
const oid ifOutDrops[]		= { 1,3,6,1,2,1,2,2,1,19,0 };
const oid ifOutErrors[]		= { 1,3,6,1,2,1,2,2,1,20,0 };
const oid ifOutQLen[]		= { 1,3,6,1,2,1,2,2,1,21,0 };

const oid ifName[]		= { 1,3,6,1,2,1,31,1,1,1,1,0 };
const oid ifInMulticastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,2,0 };
const oid ifInBroadcastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,3,0 };
const oid ifOutMulticastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,4,0 };
const oid ifOutBroadcastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,5,0 };
const oid ifHCInOctets[]	= { 1,3,6,1,2,1,31,1,1,1,6,0 };
const oid ifHCInUcastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,7,0 };
const oid ifHCInMulticastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,8,0 };
const oid ifHCInBroadcastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,9,0 };
const oid ifHCOutOctets[]	= { 1,3,6,1,2,1,31,1,1,1,10,0 };
const oid ifHCOutUcastPkts[]	= { 1,3,6,1,2,1,31,1,1,1,11,0 };
const oid ifHCOutMulticastPkts[]= { 1,3,6,1,2,1,31,1,1,1,12,0 };
const oid ifHCOutBroadcastPkts[]= { 1,3,6,1,2,1,31,1,1,1,13,0 };
const oid ifLinkUpDownTrapEnable[]= { 1,3,6,1,2,1,31,1,1,1,14,0 };
const oid ifHighSpeed[]		= { 1,3,6,1,2,1,31,1,1,1,15,0 };
const oid ifPromiscuousMode[]	= { 1,3,6,1,2,1,31,1,1,1,16,0 };
const oid ifConnectorPresent[]	= { 1,3,6,1,2,1,31,1,1,1,17,0 };
const oid ifAlias[]		= { 1,3,6,1,2,1,31,1,1,1,18,0 };

/*
 * IP Addresses table.
 */
const oid ipAdEntAddr[]		= { 1,3,6,1,2,1,4,20,1,1,0,0,0,0 };
const oid ipAdEntIfIndex[]	= { 1,3,6,1,2,1,4,20,1,2,0,0,0,0 };

/*
 * Cisco specific variables.
 */
/* OLD-CISCO-SYSTEM-MIB */
const oid ciscoProductID[]	= { 1,3,6,1,4,1,9,1,0 };
const int ciscoProductID_len	= SV_LEN(ciscoProductID);
const oid ciscoWhyReload[]	= { 1,3,6,1,4,1,9,2,1,2,0 };

const oid catalystProductID[]	= { 1,3,6,1,4,1,9,5,0 };
const int catalystProductID_len	= SV_LEN(catalystProductID);

/* OLD-CISCO-MEMORY-MIB */
const oid ciscoFreeMem[]	= { 1,3,6,1,4,1,9,2,1,8,0 };

/* OLD-CISCO-CPU-MIB */
const oid ciscoAvgBusy[]	= { 1,3,6,1,4,1,9,2,1,57,0 };

/* OLD-CISCO-INTERFACES-MIB */
const oid ciscoIfInBitsSec[]	= { 1,3,6,1,4,1,9,2,2,1,1,6,0 };
const oid ciscoIfInPktsSec[]	= { 1,3,6,1,4,1,9,2,2,1,1,7,0 };
const oid ciscoIfOutBitsSec[]	= { 1,3,6,1,4,1,9,2,2,1,1,8,0 };
const oid ciscoIfOutPktsSec[]	= { 1,3,6,1,4,1,9,2,2,1,1,9,0 };
const oid ciscoIfReason[]	= { 1,3,6,1,4,1,9,2,2,1,1,20,0 };
const oid ciscoIfDescr[]	= { 1,3,6,1,4,1,9,2,2,1,1,28,0 }; /* ifAlias */

/* CISCO-ENVMON-MIB */
/* Voltage */
const oid ciscoEnvVoltDescr[]	= { 1,3,6,1,4,1,9,9,13,1,2,1,2,0 };
const oid ciscoEnvVoltValue[]	= { 1,3,6,1,4,1,9,9,13,1,2,1,3,0 };
const oid ciscoEnvVoltThresholdLow[]={ 1,3,6,1,4,1,9,9,13,1,2,1,4,0 };
const oid ciscoEnvVoltThresholdHigh[]={ 1,3,6,1,4,1,9,9,13,1,2,1,5,0 };
const oid ciscoEnvVoltState[]	= { 1,3,6,1,4,1,9,9,13,1,2,1,7,0 };
/* Temperature */
const oid ciscoEnvTempDescr[]	= { 1,3,6,1,4,1,9,9,13,1,3,1,2,0 };
const oid ciscoEnvTempValue[]	= { 1,3,6,1,4,1,9,9,13,1,3,1,3,0 };
const oid ciscoEnvTempThreshold[]={ 1,3,6,1,4,1,9,9,13,1,3,1,4,0 };
const oid ciscoEnvTempState[]	= { 1,3,6,1,4,1,9,9,13,1,3,1,6,0 };
/* Fan cooler */
const oid ciscoEnvFanDescr[]	= { 1,3,6,1,4,1,9,9,13,1,4,1,2,0 };
const oid ciscoEnvFanState[]	= { 1,3,6,1,4,1,9,9,13,1,4,1,3,0 };
/* Power supply */
const oid ciscoEnvPSDescr[]	= { 1,3,6,1,4,1,9,9,13,1,5,1,2,0 };
const oid ciscoEnvPSState[]	= { 1,3,6,1,4,1,9,9,13,1,5,1,3,0 };
const oid ciscoEnvPSSource[]	= { 1,3,6,1,4,1,9,9,13,1,5,1,4,0 };

/*
 * BGP router variables (see BGP4-MIB: RFC-1657).
 */
const oid bgpLocalAs[]		= { 1,3,6,1,2,1,15,2,0 };
const oid bgpPeerIdentifier[]	= { 1,3,6,1,2,1,15,3,1,1,0,0,0,0 };
const oid bgpPeerState[]	= { 1,3,6,1,2,1,15,3,1,2,0,0,0,0 }; /* +trap */
const oid bgpPeerAdminStatus[]	= { 1,3,6,1,2,1,15,3,1,3,0,0,0,0 }; /* 1-stop,2-start */
const oid bgpPeerNegotiatedVersion[]={ 1,3,6,1,2,1,15,3,1,4,0,0,0,0 };
const oid bgpPeerLocalAddr[]	= { 1,3,6,1,2,1,15,3,1,5,0,0,0,0 };
const oid bgpPeerLocalPort[]	= { 1,3,6,1,2,1,15,3,1,6,0,0,0,0 };
const oid bgpPeerRemoteAddr[]	= { 1,3,6,1,2,1,15,3,1,7,0,0,0,0 }; /* PEER */
const oid bgpPeerRemotePort[]	= { 1,3,6,1,2,1,15,3,1,8,0,0,0,0 };
const oid bgpPeerRemoteAs[]	= { 1,3,6,1,2,1,15,3,1,9,0,0,0,0 }; /* AS */
const oid bgpPeerInUpdates[]	= { 1,3,6,1,2,1,15,3,1,10,0,0,0,0 };
const oid bgpPeerOutUpdates[]	= { 1,3,6,1,2,1,15,3,1,11,0,0,0,0 };
const oid bgpPeerInTotalMessages[]={ 1,3,6,1,2,1,15,3,1,12,0,0,0,0 };
const oid bgpPeerOutTotalMessages[]={ 1,3,6,1,2,1,15,3,1,13,0,0,0,0 };
const oid bgpPeerLastError[]	= { 1,3,6,1,2,1,15,3,1,14,0,0,0,0 }; /* trap */
const oid bgpPeerFsmEstablishedTime[]={ 1,3,6,1,2,1,15,3,1,16,0,0,0,0 }; /* secs */
const oid bgpPeerInUpdateElapsedTime[]={ 1,3,6,1,2,1,15,3,1,24,0,0,0,0 }; /* secs */
const oid bgpIdentifier[]	= { 1,3,6,1,2,1,15,4,0 }; /* local IP addr */
const oid bgpTrapEnterprise[]	= { 1,3,6,1,2,1,15,7 };
const int bgpTrapEnterprise_len	= SV_LEN(bgpTrapEnterprise);


const SNMP_MIB_ENTRY system_MIB[] = {
/* name		objid		objid_len		mode */
{"sysDescr",	sysDescr,	SV_LEN(sysDescr),	GET_INFO },
{"sysObjID",	sysObjID,	SV_LEN(sysObjID),	GET_STATE },
{"sysUpTime",	sysUpTime,	SV_LEN(sysUpTime),	GET_STATE },
{"sysContact",	sysContact,	SV_LEN(sysContact),	GET_INFO },
{"sysName",	sysName,	SV_LEN(sysName),	GET_INFO },
{"sysLocation",	sysLocation,	SV_LEN(sysLocation),	GET_INFO },
{"sysServices",	sysServices,	SV_LEN(sysServices),	GET_INFO },
{"ifNumber",	ifNumber,	SV_LEN(ifNumber),	GET_STATE },
#ifdef	notdef
{"bgpLocalAs",	bgpLocalAs,	SV_LEN(bgpLocalAs),	0	},
{"bgpIdentifier",bgpIdentifier,	SV_LEN(bgpIdentifier),	0	},
#endif
{0} /* end of table */
};

const SNMP_MIB_ENTRY cisco_system_MIB[] = {
{"ciscoWhyReload",	ciscoWhyReload,	SV_LEN(ciscoWhyReload),	GET_INFO },
{"ciscoFreeMem",	ciscoFreeMem,	SV_LEN(ciscoFreeMem),	GET_DATA },
{"ciscoAvgBusy",	ciscoAvgBusy,	SV_LEN(ciscoAvgBusy),	GET_DATA },
{0}
};

const SNMP_MIB_ENTRY interface_MIB[] = {
/* ifTable */
{"ifIndex",	ifIndex,	SV_LEN(ifIndex),	SCAN_MATCH |GET_STATE},
{"ifDescr",	ifDescr,	SV_LEN(ifDescr),	SCAN_MATCH |GET_STATE},
{"ifType",	ifType,		SV_LEN(ifType),		SCAN_DETECT|GET_INFO },
{"ifMtu",	ifMtu,		SV_LEN(ifMtu),		SCAN_DETECT|GET_INFO },
{"ifSpeed",	ifSpeed,	SV_LEN(ifSpeed),	SCAN_DETECT|GET_DATA },
{"ifPhysAddress",ifPhysAddress,	SV_LEN(ifPhysAddress),	SCAN_DETECT|GET_INFO },
{"ifAdminStatus",ifAdminStatus,	SV_LEN(ifAdminStatus),	SCAN_DETECT|GET_INFO },
{"ifOperStatus",ifOperStatus,	SV_LEN(ifOperStatus),	SCAN_DETECT|GET_STATE },
{"ifLastChange",ifLastChange,	SV_LEN(ifLastChange),	SCAN_DETECT|GET_INFO },
{"ifInOctets",	ifInOctets,	SV_LEN(ifInOctets),	SCAN_DETECT|GET_DATA },
{"ifInUcastPkts",ifInUcastPkts,	SV_LEN(ifInUcastPkts),	SCAN_DETECT|GET_DATA },
#ifndef USE_MULTICAST_COUNTERS
{"ifInNUcastPkts",ifInNUcastPkts,SV_LEN(ifInNUcastPkts),SCAN_DETECT|GET_DATA },
#endif
{"ifInDrops",	ifInDrops,	SV_LEN(ifInDrops),	SCAN_DETECT|GET_DATA },
{"ifInErrors",	ifInErrors,	SV_LEN(ifInErrors),	SCAN_DETECT|GET_DATA },
{"ifInUnknownProtos",ifInUnknownProtos,SV_LEN(ifInUnknownProtos),SCAN_DETECT|GET_DATA },
{"ifOutOctets",	ifOutOctets,	SV_LEN(ifOutOctets),	SCAN_DETECT|GET_DATA },
{"ifOutUcastPkts",ifOutUcastPkts,SV_LEN(ifOutUcastPkts),SCAN_DETECT|GET_DATA },
#ifndef USE_MULTICAST_COUNTERS
{"ifOutNUcastPkts",ifOutNUcastPkts,SV_LEN(ifOutNUcastPkts),SCAN_DETECT|GET_DATA },
#endif
{"ifOutDrops",	ifOutDrops,	SV_LEN(ifOutDrops),	SCAN_DETECT|GET_DATA },
{"ifOutErrors",	ifOutErrors,	SV_LEN(ifOutErrors),	SCAN_DETECT|GET_DATA },
{"ifOutQLen",	ifOutQLen,	SV_LEN(ifOutQLen),	SCAN_DETECT|GET_DATA },
/* ifXTable */
{"ifName",	ifName,		SV_LEN(ifName),		SCAN_MATCH |GET_STATE},
/*
 * Old-Style ifInNUcastPkts/ifOutNUcastPkts would be replaced on the following:
 */
#ifdef USE_MULTICAST_COUNTERS
{"ifInMulticastPkts",	ifInMulticastPkts,	SV_LEN(ifInMulticastPkts),
							SCAN_DETECT|GET_DATA },
{"ifInBroadcastPkts",	ifInBroadcastPkts,	SV_LEN(ifInBroadcastPkts),
							SCAN_DETECT|GET_DATA },
{"ifOutMulticastPkts",	ifOutMulticastPkts,	SV_LEN(ifOutMulticastPkts),
							SCAN_DETECT|GET_DATA },
{"ifOutBroadcastPkts",	ifOutBroadcastPkts,	SV_LEN(ifOutBroadcastPkts),
							SCAN_DETECT|GET_DATA },
#endif
/*
 * ifHC... is a 64-bit counters (Huge Counters), SNMP V2 required.
 */
{"ifHCInOctets",	ifHCInOctets,		SV_LEN(ifHCInOctets),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHCInUcastPkts",	ifHCInUcastPkts,	SV_LEN(ifHCInUcastPkts),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHCInMulticastPkts",	ifHCInMulticastPkts,	SV_LEN(ifHCInMulticastPkts),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHCInBroadcastPkts",	ifHCInBroadcastPkts,	SV_LEN(ifHCInBroadcastPkts),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHCOutOctets",	ifHCOutOctets,		SV_LEN(ifHCOutOctets),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHCOutUcastPkts",	ifHCOutUcastPkts,	SV_LEN(ifHCOutUcastPkts),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHCOutMulticastPkts",ifHCOutMulticastPkts,	SV_LEN(ifHCOutMulticastPkts),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHCOutBroadcastPkts",ifHCOutBroadcastPkts,	SV_LEN(ifHCOutBroadcastPkts),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifHighSpeed",		ifHighSpeed,		SV_LEN(ifHighSpeed),
							MIB_SNMP_V2|SCAN_DETECT|GET_DATA },
{"ifLinkUpDownTrapEnable",ifLinkUpDownTrapEnable,SV_LEN(ifLinkUpDownTrapEnable),
							SCAN_DETECT|GET_INFO },
{"ifPromiscuousMode",	ifPromiscuousMode,	SV_LEN(ifPromiscuousMode),
							SCAN_DETECT|GET_INFO },
{"ifConnectorPresent",	ifConnectorPresent,	SV_LEN(ifConnectorPresent),
							SCAN_DETECT|GET_INFO },
{"ifAlias",		ifAlias,		SV_LEN(ifAlias),
							SCAN_MATCH |GET_STATE},
{0}
};

const SNMP_MIB_ENTRY cisco_interface_MIB[] = {
{"ciscoIfInBitsSec",	ciscoIfInBitsSec,	SV_LEN(ciscoIfInBitsSec),
							SCAN_DETECT|GET_DATA },
{"ciscoIfInPktsSec",	ciscoIfInPktsSec,	SV_LEN(ciscoIfInPktsSec),
							SCAN_DETECT|GET_DATA },
{"ciscoIfOutBitsSec",	ciscoIfOutBitsSec,	SV_LEN(ciscoIfOutBitsSec),
							SCAN_DETECT|GET_DATA },
{"ciscoIfOutPktsSec",	ciscoIfOutPktsSec,	SV_LEN(ciscoIfOutPktsSec),
							SCAN_DETECT|GET_DATA },
{"ciscoIfReason",	ciscoIfReason,		SV_LEN(ciscoIfReason),
							SCAN_DETECT|GET_INFO },
{0}
};

/* variable that match IP address must be FIRST! */
const SNMP_MIB_ENTRY ipaddr_MIB[] = {
{"ipAdEntAddr",		ipAdEntAddr,	SV_LEN(ipAdEntAddr),	SCAN_MATCH },
{"ipAdEntIfIndex",	ipAdEntIfIndex,	SV_LEN(ipAdEntIfIndex),	SCAN_MATCH },
{0}
};

/* variable that match AS number must be FIRST! */
const SNMP_MIB_ENTRY bgp_MIB[] = {
{"bgpPeerRemoteAs",	bgpPeerRemoteAs,	SV_LEN(bgpPeerRemoteAs),
							SCAN_MATCH|GET_STATE },
{"bgpPeerRemoteAddr",	bgpPeerRemoteAddr,	SV_LEN(bgpPeerRemoteAddr),
							SCAN_MATCH },
{"bgpPeerIdentifier",	bgpPeerIdentifier,	SV_LEN(bgpPeerIdentifier),
							SCAN_DETECT|GET_INFO },
{"bgpPeerState",	bgpPeerState,		SV_LEN(bgpPeerState),
							SCAN_DETECT|GET_STATE },
{"bgpPeerAdminStatus",	bgpPeerAdminStatus,	SV_LEN(bgpPeerAdminStatus),
							SCAN_DETECT|GET_INFO },
{"bgpPeerInUpdates",	bgpPeerInUpdates,	SV_LEN(bgpPeerInUpdates),
							SCAN_DETECT|GET_DATA },
{"bgpPeerOutUpdates",	bgpPeerOutUpdates,	SV_LEN(bgpPeerOutUpdates),
							SCAN_DETECT|GET_DATA },
/*
{"bgpPeerInTotalMessages",bgpPeerInTotalMessages,SV_LEN(bgpPeerInTotalMessages),
							SCAN_DETECT|GET_DATA },
{"bgpPeerOutTotalMessages",bgpPeerOutTotalMessages,SV_LEN(bgpPeerOutTotalMessages),
							SCAN_DETECT|GET_DATA },
*/
{"bgpPeerLastError",	bgpPeerLastError,	SV_LEN(bgpPeerLastError),
							SCAN_DETECT|GET_INFO },
{"bgpPeerFsmEstablishedTime",bgpPeerFsmEstablishedTime,SV_LEN(bgpPeerFsmEstablishedTime),
							SCAN_DETECT|GET_INFO },
{"bgpPeerInUpdateElapsedTime",bgpPeerInUpdateElapsedTime,SV_LEN(bgpPeerInUpdateElapsedTime),
							SCAN_DETECT|GET_STATE },
{0}
};

const SNMP_MIB_ENTRY cisco_envtemp_MIB[] = {
{"ciscoEnvTempDescr",	ciscoEnvTempDescr,	SV_LEN(ciscoEnvTempDescr),
							SCAN_MATCH },
{"ciscoEnvTempValue",	ciscoEnvTempValue,	SV_LEN(ciscoEnvTempValue),
							SCAN_DETECT|GET_DATA },
{"ciscoEnvTempThreshold",ciscoEnvTempThreshold,	SV_LEN(ciscoEnvTempThreshold),
							SCAN_DETECT|GET_INFO },
{"ciscoEnvTempState",	ciscoEnvTempState,	SV_LEN(ciscoEnvTempState),
							SCAN_DETECT|GET_STATE },
{0}
};

const SNMP_MIB_ENTRY cisco_envvolt_MIB[] = {
{"ciscoEnvVoltDescr",	ciscoEnvVoltDescr,	SV_LEN(ciscoEnvVoltDescr),
							SCAN_MATCH },
{"ciscoEnvVoltValue",	ciscoEnvVoltValue,	SV_LEN(ciscoEnvVoltValue),
							SCAN_DETECT|GET_DATA },
{"ciscoEnvVoltThresholdLow",ciscoEnvVoltThresholdLow,SV_LEN(ciscoEnvVoltThresholdLow),
							SCAN_DETECT|GET_INFO },
{"ciscoEnvVoltThresholdHigh",ciscoEnvVoltThresholdHigh,SV_LEN(ciscoEnvVoltThresholdHigh),
							SCAN_DETECT|GET_INFO },
{"ciscoEnvVoltState",	ciscoEnvVoltState,	SV_LEN(ciscoEnvVoltState),
							SCAN_DETECT|GET_STATE },
{0}
};

const SNMP_MIB_ENTRY cisco_envfan_MIB[] = {
{"ciscoEnvFanDescr",	ciscoEnvFanDescr,	SV_LEN(ciscoEnvFanDescr),
							SCAN_MATCH },
{"ciscoEnvFanState",	ciscoEnvFanState,	SV_LEN(ciscoEnvFanState),
							SCAN_DETECT|GET_STATE },
{0}
};

const SNMP_MIB_ENTRY cisco_envps_MIB[] = {
{"ciscoEnvPSDescr",	ciscoEnvPSDescr,	SV_LEN(ciscoEnvPSDescr),
							SCAN_MATCH },
{"ciscoEnvPSState",	ciscoEnvPSState,	SV_LEN(ciscoEnvPSState),
							SCAN_DETECT|GET_STATE },
{"ciscoEnvPSSource",	ciscoEnvPSSource,	SV_LEN(ciscoEnvPSSource),
							SCAN_DETECT|GET_INFO },
{0}
};

static const SNMP_MIB_ENTRY *total_MIB[] = {
	system_MIB,
	interface_MIB,
	ipaddr_MIB,
	bgp_MIB,
	cisco_system_MIB,
	cisco_interface_MIB,
	cisco_envtemp_MIB,
	cisco_envvolt_MIB,
	cisco_envfan_MIB,
	cisco_envps_MIB,

	0 /* end of table */
};

static void
dump_table(table)
	const SNMP_MIB_ENTRY *table;
{
	const SNMP_MIB_ENTRY *entry;
	char tmpbuf[1024];

	for (entry = table; entry && entry->name; entry++) {
		printf("$%s", entry->name);
		if (entry->objid) {
			if (strlen(entry->name) < 7)
				printf("\t");
			printf("\t%s", oid2str(tmpbuf, entry->objid, entry->objid_len));
			if (entry->mode) {
				printf("\t");
				if (entry->mode & MIB_SNMP_V1)
					printf(" V1");
				if (entry->mode & MIB_SNMP_V2)
					printf(" V2");
				if (entry->mode & SCAN_MATCH)
					printf(" MATCH");
				if (entry->mode & SCAN_DETECT)
					printf(" DETECT");
				if (entry->mode & GET_STATE)
					printf(" STATE");
				if (entry->mode & GET_INFO)
					printf(" INFO");
				if (entry->mode & GET_DATA)
					printf(" DATA");
			}
		}
		printf("\n");
	}
}

void
dump_mib_table(table)
	const SNMP_MIB_ENTRY *table;
{
	if (!table) { /* any table */
		const SNMP_MIB_ENTRY **tab = total_MIB;
		for (; tab && *tab; tab++) {
			dump_table(*tab);
			printf("\n");
		}
	} else dump_table(table);
}

static const SNMP_MIB_ENTRY *
get_entry(name, table)
	const char *name;
	const SNMP_MIB_ENTRY *table;
{
	if (name && table) {
		const SNMP_MIB_ENTRY *entry;
		for (entry = table; entry && entry->name; entry++) {
			if (!strcasecmp(entry->name, name))
				return entry;
		}
	}
	return 0;
}

static const char *
get_name(objid, objid_len, table)
	const oid *objid;
	int *objid_len; /* IN: objid total length, OUT: rest instance length */
	const SNMP_MIB_ENTRY *table;
{
	const SNMP_MIB_ENTRY *entry;
	int i, instance_len;

	if (!objid || !objid_len || *objid_len < 4 || !table)
		return 0;

	for (entry = table; entry && entry->name; entry++) {
		if (entry->objid_len < 4 || entry->objid_len != *objid_len)
			continue;
		instance_len = 0;
		for (i = 0; i < entry->objid_len; i++) {
			if (entry->objid[i] != objid[i]) {
				if (entry->objid[i])
					break;
				instance_len++;
			} else	instance_len = 0;
		}
		if (i == entry->objid_len) {
			*objid_len = instance_len;
			return entry->name;
		}
	}
	return 0;
}

const SNMP_MIB_ENTRY *
get_mib_entry(name, table)
	const char *name;
	const SNMP_MIB_ENTRY *table;
{
	if (!name || *name == 0)
		return 0;
	if (!table) { /* any table */
		const SNMP_MIB_ENTRY **tab = total_MIB;
		for (; tab && *tab; tab++) {
			const SNMP_MIB_ENTRY *entry = get_entry(name, *tab);
			if (entry) return entry;
		}
		return 0;
	}
	return get_entry(name, table);
}

const char *
get_mib_name(objid, objid_len, table)
	const oid *objid;
	int *objid_len; /* IN: objid total length, OUT: rest instance length */
	const SNMP_MIB_ENTRY *table;
{
	if (!objid || !objid_len || *objid_len < 4)
		return 0;
	if (!table) { /* any table */
		const SNMP_MIB_ENTRY **tab = total_MIB;
		for (; tab && *tab; tab++) {
			const char *name = get_name(objid, objid_len, *tab);
			if (name) return name;
		}
		return 0;
	}
	return get_name(objid, objid_len, table);
}

int
get_mib_mode(name, table)
	const char *name;
	const SNMP_MIB_ENTRY *table;
{
	const SNMP_MIB_ENTRY *entry = get_mib_entry(name, table);
	if (entry) return entry->mode;
	return 0;
}

/* append MIB table to the list of variables */
void
add_mib_table(chain, table, ver)
	VARIABLE **chain;
	const SNMP_MIB_ENTRY *table;
	int ver;
{
	VARIABLE *var, *last;
	const SNMP_MIB_ENTRY *entry;

	/* sanity check */
	if (!chain || !table) return;

	/* find last to append later */
	last = *chain;
	while (last) {
		if (!last->next) break;
		last = last->next;
	}
	for (entry = table; entry && entry->name; entry++) {
		/* sanity check */
		if (!entry->objid || entry->objid_len < 1)
			continue;

		/* check for version required */
		if ((entry->mode & MIB_SNMP_VERSION) == 0 ||
		    (ver == SNMP_VERSION_1 && (entry->mode & MIB_SNMP_V1) != 0) ||
		    (ver == SNMP_VERSION_2 && (entry->mode & MIB_SNMP_V2) != 0)) {
			/* prevent dups */
			if (*chain && get_var(*chain, entry->name) != 0)
				continue;

			var = make_var(entry->name,
				       entry->objid, entry->objid_len,
				       entry->mode);
			if (!var) return;

			if (last)
				last->next = var;
			else	*chain = var;
			last = var;
		}
	}
}

void
free_mib_table(chain, table)
	VARIABLE **chain;
	const SNMP_MIB_ENTRY *table;
{
	VARIABLE *var, *next, *prev = 0;

	/* sanity check */
	if (!chain) return;

	for (var = *chain; var; var = next) {
		next = var->next;
		if (get_mib_entry(var->name, table)) {
			free_var(var);
			if (prev) prev->next = next;
			else *chain = next;
		} else	prev = var;
	}
}

