/* regex.h - prototypes for Ozan Yigit's regex functions in regex.c */

/*  Copyright 1991 Mark Russell, University of Kent at Canterbury.
 *
 *  You can do what you like with this source code as long as
 *  you don't try to make money out of it and you include an
 *  unaltered copy of this message (including the copyright).
 */

/* @(#)regex.h	1.3 17 Apr 1994 (UKC) */

#ifndef	__REGEX_H_
#define	__REGEX_H_

#define	EXTEND
#define	YRE_SUBS_FAIL

/*
 * The following defines are not meant to be changeable.
 * They are for readibility only.
 */
#define MAXDFA  1024
#define MAXTAG  10
#define MAXCHR	128
#define CHRBIT	8
#define BITBLK	MAXCHR/CHRBIT
#define BLKIND	0170
#define BITIND	07
#define ASCIIB	0177

typedef /*unsigned*/ char CHAR;

typedef struct {
	/* compiled by yre_comp() first */
	CHAR dfa[MAXDFA];	/* automaton..       */
	CHAR bittab[BITBLK];	/* bit table for CCL */
	int tagstk[MAXTAG];	/* subpat tag stack..*/

	/* used by subsequent functions such as yre_exec() */
	char *bopat[MAXTAG], *eopat[MAXTAG];
	char *bol;
} yre_t;

char *yre_comp __P((yre_t *prog, char *pat));
int yre_exec __P((yre_t *prog, char *lp));
int e_re_exec __P((yre_t *prog, char *lp, int offset, int *p_start, int *p_end));
void yre_modw __P((char *set));
int yre_subs __P((yre_t *prog, char *src, char *dst));

#endif /* !__REGEX_H_ */
